#include <systemc.h>
#include <stdlib.h>
#include <iostream>


SC_MODULE(mod)
{
	sc_signal<bool> reset;
	sc_clock clk;
	
	enum state1 {P1_INI, P1_READ1, P1_READ2, P1_END};
	enum state2 {P2_INI, P2_WRITE1, P2_WRITE2, P2_END};
	
	int s1, next_s1;
	int acc;

	int s2, next_s2;
	
	bool valid1, valid2;
	int buffer;

	void change_state()
	{
		s1 = next_s1;
		s2 = next_s2;
	}
	
	void p1()
	{
		switch(s1)
		{
			case P1_INI:
				valid1 = false;
				next_s1 = P1_READ1;
				break;
			case P1_READ1:
				if(valid2 == true){
					acc = buffer;
					next_s1 = P1_READ2;
					valid2 = false;
				}
				break;
			case P1_READ2:
				if(valid2 == true){
					buffer++;
					valid1 = true;
					valid2 = false;
					next_s1 = P1_END;
				}
				break;
			case P1_END:
				if(valid1 == false){
					next_s1 = P1_READ1;
				}
				break;
		}
	}

	void p2()
	{
		switch(s2)
		{
			case P2_INI:
				valid2 = false;
				next_s2 = P2_WRITE1;
				break;
			case P2_WRITE1:
				buffer++;
				//std::cout << buffer;
				valid2 = true;
				next_s2 = P2_WRITE2;
			case P2_WRITE2:
				if(valid2 == false){
					buffer++;
					//std::cout << " + " << buffer;
					valid2 = true;
					next_s2 = P2_END;
				}
			case P2_END:
				if(valid1 == true){
				//	std::cout << " = " << buffer << std::endl;
					valid1 = false;
					next_s2 = P2_WRITE1;
				}
		}
				
	}

	SC_CTOR(mod)
	{
		SC_METHOD(p1);
		sensitive << clk;

		s1 = next_s1 = P1_INI;

		SC_METHOD(p2);
		sensitive << clk;

		s2 = next_s2 = P2_INI;

		SC_METHOD(change_state);
		sensitive << clk;
	}
};

int sc_main(int argc, char* argv[])
{
	mod m("mod");
	sc_start(TIME);
	return 0;
}
