#ifndef TLM_FIFO_PORTS_HEADER
#define TLM_FIFO_PORTS_HEADER

#include <tlm.h>
#include <tlm_h/tlm_req_rsp/tlm_1_interfaces/tlm_core_ifs.h>

namespace tlm
{
	
//---------------------------------------------------------------
// tlm-fifo non-blocking input port
//---------------------------------------------------------------

template <class T>
class tlm_fifo_nb_in: public sc_port<tlm_nonblocking_get_peek_if<T> >
{
  typedef tlm_nonblocking_get_peek_if<T> IF;
  public:
  tlm_fifo_nb_in(){}
  tlm_fifo_nb_in(const char* name): sc_port<IF>(name){}

  bool nb_get(T& t)
  {
    return (*this)->nb_get(t);
  }

  bool nb_peek(T& t) const
  {
    return (*this)->nb_peek(t);
  }
};


//---------------------------------------------------------------
// tlm-fifo non-blocking output port
//---------------------------------------------------------------

template <class T>
class tlm_fifo_nb_out: public sc_port<tlm_nonblocking_put_if<T> >
{
  typedef tlm_nonblocking_put_if<T> IF;
  public:
  tlm_fifo_nb_out(){}
  tlm_fifo_nb_out(const char* name): sc_port<IF>(name){}

  bool nb_put(const T& t)
  {
    return (*this)->nb_put(t);
  }
};

}
#endif

